(*        GREATIS DELPHI PAGES         *)
(* Copyright (C) 2001 Greatis Software *)
(*  web: http://www.greatisdelphi.com  *)
(*     e-mail: delphi@greatis.com      *)

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Memo1: TMemo;
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Memo1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function IndexInParent(VControl: TControl): integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  MessageBox(Handle, PChar('Index = '+IntToStr(IndexInParent(Button1))), 'Information', MB_OK);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  MessageBox(Handle, PChar('Index = '+IntToStr(IndexInParent(Button2))), 'Information', MB_OK);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  MessageBox(Handle, PChar('Index = '+IntToStr(IndexInParent(Button3))), 'Information', MB_OK);
end;

function TForm1.IndexInParent(VControl: TControl): Integer;
var
  ParentControl: TWinControl;
begin
  ParentControl:=TForm(VControl.Parent);
  if (ParentControl<>nil) then
    for Result:=0 to ParentControl.ControlCount-1 do
      if (ParentControl.Controls[Result]=VControl) then
        Exit;
  Result:=-1;
end;

procedure TForm1.Memo1Click(Sender: TObject);
begin
  MessageBox(Handle, PChar('Index = '+IntToStr(IndexInParent(Memo1))), 'Information', MB_OK);
end;

end.
